/*
 * source@source.blackcore.net
 * Copyright 2006 blackcore networking
 *
 * cl list.cpp advapi32.lib
 * list.exe <pid>
 * Use at your own risk!
*/
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <windows.h>
#include <stdlib.h>
#include <fcntl.h>
#include <io.h>
#include <sys/types.h>
#include <sys/stat.h>
char searchstring[64], outfile[64];
int flags = 0, searchlen = 0, incrval = 1;
char *GetError() 
{ 

    LPVOID lpMsgBuf;
    DWORD dw = GetLastError(); 

    FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | 
        FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        dw,
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
        (LPTSTR) &lpMsgBuf,
        0, NULL );
    /*wsprintf(szBuf, 
        "%s failed with error %d: %s", 
        lpszFunction, dw, lpMsgBuf);  */
 
    return (char *)lpMsgBuf;

    //LocalFree(lpMsgBuf);
}

void dumpval(unsigned char *buf, int toread) {
	int i, x, y;
	while(toread > 0) {
		if (toread-16 > 0)
			y = 16;
		else
			y = toread;
		for(x=0;x<y;x++) {
			printf("%02X ", buf[x]);
		}
		for(x=0;x<y;x++) {
			if (buf[x] >= 33 && buf[x] < 123) {
				printf("%c", buf[x]);
			} else {
				printf(".");
			}
		}
		printf("\n");
		toread-=16;
	}
}
int logcall(char *fmt, ...) {
	int n;
	char buf[512];
	FILE *fd;
	va_list vargs;
	va_start(vargs, fmt);
	memset(buf, 0, 512);
	n=_vsnprintf(buf, 512, fmt, vargs);
	if ((fd = fopen("list.txt", "a"))) {
		fputs(buf, fd);
		fclose(fd);
	}
	fputs(buf, stdout);
	va_end(vargs);
	return n;
}
BOOL SetPrivilege(
    HANDLE hToken,          // token handle
    LPCTSTR Privilege,      // Privilege to enable/disable
    BOOL bEnablePrivilege   // TRUE to enable.  FALSE to disable
    ) {
    TOKEN_PRIVILEGES tp;
    LUID luid;
    TOKEN_PRIVILEGES tpPrevious;
    DWORD cbPrevious=sizeof(TOKEN_PRIVILEGES);

    if(!LookupPrivilegeValue( NULL, Privilege, &luid )) return FALSE;

    //
    // first pass.  get current privilege setting
    //
    tp.PrivilegeCount           = 1;
    tp.Privileges[0].Luid       = luid;
    tp.Privileges[0].Attributes = 0;

    AdjustTokenPrivileges(
            hToken,
            FALSE,
            &tp,
            sizeof(TOKEN_PRIVILEGES),
            &tpPrevious,
            &cbPrevious
            );

    if (GetLastError() != ERROR_SUCCESS) return FALSE;

    //
    // second pass.  set privilege based on previous setting
    //
    tpPrevious.PrivilegeCount       = 1;
    tpPrevious.Privileges[0].Luid   = luid;

    if(bEnablePrivilege) {
        tpPrevious.Privileges[0].Attributes |= (SE_PRIVILEGE_ENABLED);
    }
    else {
        tpPrevious.Privileges[0].Attributes ^= (SE_PRIVILEGE_ENABLED &
            tpPrevious.Privileges[0].Attributes);
    }

    AdjustTokenPrivileges(
            hToken,
            FALSE,
            &tpPrevious,
            cbPrevious,
            NULL,
            NULL
            );

    if (GetLastError() != ERROR_SUCCESS) return FALSE;

    return TRUE;
}

int DoTokenAdjust() {
	HANDLE hToken;
	if (!OpenThreadToken(GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, FALSE, &hToken)) {
		if (GetLastError() == ERROR_NO_TOKEN) { 
			if (!ImpersonateSelf(SecurityImpersonation)) {
				printf("IS failed\n");
				return 1;
			}
			if (!OpenThreadToken(GetCurrentThread(), TOKEN_ADJUST_PRIVILEGES|TOKEN_QUERY, FALSE, &hToken)) {
				printf("OTT2\n");
				return 1;
			}
		} else { printf("OTT failed\n"); return 1; }
	}
	if (!SetPrivilege(hToken, SE_DEBUG_NAME, TRUE)) {
		printf("could not set sedebug\n");
		return 1;
	}
	return 0;
}
char *gettype(int in, int type) {
	static char retval[32];
	memset(retval,0,sizeof(retval));

	if (type == 0) {
		switch(in) {
			case MEM_PRIVATE:
				strcpy(retval, "MEM_PRIVATE");
			break;
			case MEM_MAPPED:
				strcpy(retval, "MEM_MAPPED");
			break;
			case MEM_IMAGE:
				strcpy(retval, "MEM_IMAGE");
			break;
			default:
				strcpy(retval, "UNKNOWN");
			break;
		}
	}
	return retval;
}
unsigned long total_mem = 0, total = 0;
void sig_int(int sig) {
	printf("%lu memory\n", total_mem);
	ExitProcess(0);
	return;
}
#define SHOW_DUMP
//#define SEARCHSTRING "Google"

void ReadBlock(HANDLE hProcess, void *l, int toread) {
	DWORD dOld, dOut;
	int i, x, y, b;
	char *buf;
/*	if (VirtualProtectEx(hProcess, (void *)l, toread, , &dOld)  == 0) {
		return;
	} */
	buf = (char *)malloc(toread);
	if (buf == NULL) {
		printf("failed to malloc\n");
		ExitProcess(0);
	}
	memset(buf, 0, toread);
	if (ReadProcessMemory(hProcess, (const void *)l, buf, toread, &dOut) == 0) {
		free(buf);
		return;
	}
	if (dOut != toread) {
		printf("%d != %d (%p)\n", toread, dOut, l);
	}
//	printf("# Dump %p (%d)\n", l, toread);

	if (outfile[0] != 0) {
		if (outfile[0] == '-') {
			write(1, buf, toread);
		} else {
			FILE *fd = fopen(outfile,"ab");
			total+=_write(fileno(fd), buf, toread);
			fclose(fd);
		}
	}
	if (flags & 2) {
		for(i=0;i<dOut;) {
	//		printf("%p ", (int)(l)+(int)(i));
			printf("%p ", (int)(l) + (int)(i));
			for(x=i;((x < dOut) && (x < i+16));x++)
				printf("%02X ", (unsigned char)buf[x]);
			for(x=i;((x < dOut) && (x < i+16));x++) {
				if ((unsigned char)buf[x] >= 32 && (unsigned char)buf[x] < 123)
					printf("%c", buf[x]);
				else
					printf(".", buf[x]);
			}
			i+=16;
			printf("\n");
		}
	}
	if (searchstring[0] != 0) {
		for(i=0;i<dOut-searchlen;i++) {
			b=0;
			x = i;
			for(x=i, y=0;x<searchlen+i;x++, y++) {
				if (searchstring[y] == '?') { continue; }
				if (buf[x] != searchstring[y]) {
					b = 1;
					break;
				}
			}
			if (b == 0) {
				logcall("found at (%p) %p\n", ((int)l), ((int)l)+(int)(i));
				dumpval((unsigned char *)&buf[i], 32);
/*				{
					char newbuf[]="s\x00c\x00";
					unsigned long mineout;
printf("Size to out %d\n", sizeof(newbuf));
					printf("write: %d\n", WriteProcessMemory(hProcess, (void*)((int)l+(int)i), newbuf, sizeof(newbuf), &mineout));
					printf("mineout = %d\n", mineout);
				} */
			}
//			if (!memcmp(&buf[i], searchstring, searchlen)) {
//				logcall("found at (%p) %p\n", ((int)l), ((int)l)+(int)(i));
		}
	}
	free(buf);
}
int main(int argc, char *argv[]) {
	int pid, len, dwlen;
	HANDLE hProcess;
	MEMORY_BASIC_INFORMATION membasic;
	SYSTEM_INFO si;
	long l;
	GetSystemInfo(&si);
	printf("%p && %p\n", si.lpMinimumApplicationAddress,si.lpMaximumApplicationAddress);
	if (argc < 2) {
		printf("usage: %s <pid> <address> [string]\n", argv[0]);
		printf("<address> should be - when searching for string\n");
		printf("If <address> begins with a colen, output will stop and a binary output will be placed into the file.\n");
		printf("%s <pid> :filename.txt\n", argv[0]);
		return 1;
	}
	memset(searchstring, 0, sizeof(searchstring));
	DoTokenAdjust();
	signal(2, &sig_int);
	pid = atoi(argv[1]);
	if ((hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pid)) == INVALID_HANDLE_VALUE) {
		perror("openProcess");
		return 1;
	}
	printf("chosen pid %d (argc=%d)\n", pid, argc);
	flags |= 2;
	memset(outfile, 0, sizeof(outfile));
	if (argc < 3) {
		l = (long)si.lpMinimumApplicationAddress;
	} else if (argc != 4) {
		strncpy(outfile, argv[2], sizeof(outfile));
		if (outfile[0] == ':') {
			strncpy(outfile, &outfile[1], sizeof(outfile));
			printf("outfile: %s\n", outfile);
			l = (long)si.lpMinimumApplicationAddress;
			flags &= ~2;
		} else {
			memset(outfile, 0, sizeof(outfile));
			l = strtoul(argv[2], 0, 16);
			memset(&membasic, 0, sizeof(membasic));
			len = VirtualQueryEx(hProcess, (const void *)l, &membasic, sizeof(MEMORY_BASIC_INFORMATION));
			if (len != 28) {
				printf("VirtualQueryEx: %s\n", GetError());
			} else {
				printf("reading (or=%p, %p, and base=%p) (size=%d)\n", l, membasic.AllocationBase, membasic.BaseAddress, membasic.RegionSize);
				ReadBlock(hProcess, membasic.AllocationBase, membasic.RegionSize);
			}
			return 0;
		}
	} else if (argc != 3) {
		strncpy(searchstring, argv[3], sizeof(searchstring));
/*		if (searchstring[0] == '?') {
			flags |= 8; // unicode;
			strncpy(searchstring, &searchstring[1], sizeof(searchstring));
			searchlen = strlen(searchstring) * 2;
			incrval = 2;
		} else { */
			searchlen = strlen(searchstring);
//		}
		flags &= ~2;
		printf("string set to %s (%d:%d)\n", searchstring, searchlen, incrval);
	}
	printf("flags = %d\n", flags);
	while(l < (long)si.lpMaximumApplicationAddress) {
		memset(&membasic, 0, sizeof(membasic));
		len = VirtualQueryEx(hProcess, (const void *)l, &membasic, sizeof(MEMORY_BASIC_INFORMATION));
		if (len == 28) {
			if ((membasic.Type == MEM_PRIVATE) && membasic.State == MEM_COMMIT) {
//			if (membasic.State == MEM_COMMIT) {
				if (membasic.RegionSize > 0) {
					ReadBlock(hProcess, membasic.BaseAddress, membasic.RegionSize);
					total_mem += membasic.RegionSize;
//void ReadBlock(HANDLE hProcess, void *l, int toread) {

				}
			} else {
//				printf("%p - %s\n", l, gettype(membasic.Type,0));
			}
			l = (long)membasic.BaseAddress + membasic.RegionSize;
		} else {
			break;
		}
	}
	printf("break at %p\n", l);
	printf("error was %s\n", GetError());
	printf("%.2fKB total bytes\n", (double)(total_mem / 1024));
	printf("%.2fKB bytes written\n", (double)(total/1024));
	return 0;
}

